/*
 * Blockdaemon REST API
 *
 * Blockdaemon REST API provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple protocols/cryptocurrencies.  [Documentation](https://docs.blockdaemon.com/reference/rest-api-overview)  ### Currently supported protocols:  * algorand   * mainnet * avalanche    * mainnet-c/testnet-c * bitcoin   * mainnet/testnet * bitcoincash   * mainnet/testnet * dogecoin   * mainnet/testnet * ethereum   * mainnet/holesky/sepolia * fantom   * mainnet/testnet * litecoin   * mainnet/testnet * near   * mainnet * optimism   * mainnet * polkadot   * mainnet/westend * polygon   * mainnet/amoy * solana   * mainnet/testnet * stellar   * mainnet/testnet * tezos   * mainnet * tron   * mainnet/nile * xrp   * mainnet  ### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available.
 *
 * API version: 3.0.0
 * Contact: support@blockdaemon.com
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package ubiquity

import (
	"encoding/json"
)

// ProtocolDetail struct for ProtocolDetail
type ProtocolDetail struct {
	// The protocol handle.
	Handle *string `json:"handle,omitempty"`
	// The specified network type.
	Network interface{} `json:"network,omitempty"`
	// The genesis number.
	GenesisNumber *int64 `json:"genesis_number,omitempty"`
	// The supported endpoints.
	Endpoints *[]string `json:"endpoints,omitempty"`
}

// NewProtocolDetail instantiates a new ProtocolDetail object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewProtocolDetail() *ProtocolDetail {
	this := ProtocolDetail{}
	return &this
}

// NewProtocolDetailWithDefaults instantiates a new ProtocolDetail object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewProtocolDetailWithDefaults() *ProtocolDetail {
	this := ProtocolDetail{}
	return &this
}

// GetHandle returns the Handle field value if set, zero value otherwise.
func (o *ProtocolDetail) GetHandle() string {
	if o == nil || o.Handle == nil {
		var ret string
		return ret
	}
	return *o.Handle
}

// GetHandleOk returns a tuple with the Handle field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProtocolDetail) GetHandleOk() (*string, bool) {
	if o == nil || o.Handle == nil {
		return nil, false
	}
	return o.Handle, true
}

// HasHandle returns a boolean if a field has been set.
func (o *ProtocolDetail) HasHandle() bool {
	if o != nil && o.Handle != nil {
		return true
	}

	return false
}

// SetHandle gets a reference to the given string and assigns it to the Handle field.
func (o *ProtocolDetail) SetHandle(v string) {
	o.Handle = &v
}

// GetNetwork returns the Network field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ProtocolDetail) GetNetwork() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.Network
}

// GetNetworkOk returns a tuple with the Network field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ProtocolDetail) GetNetworkOk() (*interface{}, bool) {
	if o == nil || o.Network == nil {
		return nil, false
	}
	return &o.Network, true
}

// HasNetwork returns a boolean if a field has been set.
func (o *ProtocolDetail) HasNetwork() bool {
	if o != nil && o.Network != nil {
		return true
	}

	return false
}

// SetNetwork gets a reference to the given interface{} and assigns it to the Network field.
func (o *ProtocolDetail) SetNetwork(v interface{}) {
	o.Network = v
}

// GetGenesisNumber returns the GenesisNumber field value if set, zero value otherwise.
func (o *ProtocolDetail) GetGenesisNumber() int64 {
	if o == nil || o.GenesisNumber == nil {
		var ret int64
		return ret
	}
	return *o.GenesisNumber
}

// GetGenesisNumberOk returns a tuple with the GenesisNumber field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProtocolDetail) GetGenesisNumberOk() (*int64, bool) {
	if o == nil || o.GenesisNumber == nil {
		return nil, false
	}
	return o.GenesisNumber, true
}

// HasGenesisNumber returns a boolean if a field has been set.
func (o *ProtocolDetail) HasGenesisNumber() bool {
	if o != nil && o.GenesisNumber != nil {
		return true
	}

	return false
}

// SetGenesisNumber gets a reference to the given int64 and assigns it to the GenesisNumber field.
func (o *ProtocolDetail) SetGenesisNumber(v int64) {
	o.GenesisNumber = &v
}

// GetEndpoints returns the Endpoints field value if set, zero value otherwise.
func (o *ProtocolDetail) GetEndpoints() []string {
	if o == nil || o.Endpoints == nil {
		var ret []string
		return ret
	}
	return *o.Endpoints
}

// GetEndpointsOk returns a tuple with the Endpoints field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProtocolDetail) GetEndpointsOk() (*[]string, bool) {
	if o == nil || o.Endpoints == nil {
		return nil, false
	}
	return o.Endpoints, true
}

// HasEndpoints returns a boolean if a field has been set.
func (o *ProtocolDetail) HasEndpoints() bool {
	if o != nil && o.Endpoints != nil {
		return true
	}

	return false
}

// SetEndpoints gets a reference to the given []string and assigns it to the Endpoints field.
func (o *ProtocolDetail) SetEndpoints(v []string) {
	o.Endpoints = &v
}

func (o ProtocolDetail) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Handle != nil {
		toSerialize["handle"] = o.Handle
	}
	if o.Network != nil {
		toSerialize["network"] = o.Network
	}
	if o.GenesisNumber != nil {
		toSerialize["genesis_number"] = o.GenesisNumber
	}
	if o.Endpoints != nil {
		toSerialize["endpoints"] = o.Endpoints
	}
	return json.Marshal(toSerialize)
}

type NullableProtocolDetail struct {
	value *ProtocolDetail
	isSet bool
}

func (v NullableProtocolDetail) Get() *ProtocolDetail {
	return v.value
}

func (v *NullableProtocolDetail) Set(val *ProtocolDetail) {
	v.value = val
	v.isSet = true
}

func (v NullableProtocolDetail) IsSet() bool {
	return v.isSet
}

func (v *NullableProtocolDetail) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableProtocolDetail(val *ProtocolDetail) *NullableProtocolDetail {
	return &NullableProtocolDetail{value: val, isSet: true}
}

func (v NullableProtocolDetail) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableProtocolDetail) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
